﻿local tweak_data_ref = nil
local data_path = ModPath .. "menu/settings.json"

Hooks:PreHook(CopBase, "init", "GenSec_init", function(self, tweak_data)
	tweak_data_ref = tweak_data
	self.gsoed_menu_data = {}

	local file = io.open( data_path, "r" )
	if file then
		self.gsoed_menu_data = json.decode( file:read("*all") )
		file:close()
	end
    if not self.gsoed_menu_data.medic_rifle then self.gsoed_menu_data.medic_rifle = false end
    if not self.gsoed_menu_data.medic_shotgun then self.gsoed_menu_data.medic_shotgun = false end
end)

--Sets up the Medic's weapons
local medic_rifle_city = {
	"g36"
}
local medic_shotgun_city = {
	"benelli"
}
local rifle_weapon_mapping = {
	[("units/payday2/characters/ene_medic_m4/ene_medic_m4"):key()] = medic_rifle_city
}
local shotgun_weapon_mapping = {
	[("units/payday2/characters/ene_medic_r870/ene_medic_r870"):key()] = medic_shotgun_city
}

Hooks:PreHook(CopBase, "post_init", "GenSec_post_init", function(self)
	local rifle_weapon_swap = rifle_weapon_mapping[self._unit:name():key()]
	local shotgun_weapon_swap = shotgun_weapon_mapping[self._unit:name():key()]

	if rifle_weapon_swap and self.gsoed_menu_data.medic_rifle then
		self._default_weapon_id = type(rifle_weapon_swap) == "table" and table.random(rifle_weapon_swap) or rifle_weapon_swap
	end
	if shotgun_weapon_swap and self.gsoed_menu_data.medic_shotgun then
		self._default_weapon_id = type(shotgun_weapon_swap) == "table" and table.random(shotgun_weapon_swap) or shotgun_weapon_swap
	end
end)