﻿local tweak_data_ref = nil
local data_path = ModPath .. "menu/settings.json"

Hooks:PreHook(GroupAITweakData, "init", "GenSec_init", function(self, tweak_data)
	tweak_data_ref = tweak_data
	self.gsoed_menu_data = {}

	local file = io.open( data_path, "r" )
	if file then
		self.gsoed_menu_data = json.decode( file:read("*all") )
		file:close()
	end
    if not self.gsoed_menu_data.light_rifleman then self.gsoed_menu_data.light_rifleman = 1 end
    if not self.gsoed_menu_data.light_shotgunner then self.gsoed_menu_data.light_shotgunner = 1 end
    if not self.gsoed_menu_data.zeal_marksman then self.gsoed_menu_data.zeal_marksman = false end
end)

Hooks:PostHook(GroupAITweakData, "_init_unit_categories", "GenSec_init_unit_categories", function(self, difficulty_index)
--Main spawns
	if difficulty_index <= 8 then
		self.unit_categories.CS_shield.unit_types.america = {
			Idstring("units/payday2/characters/ene_city_shield/ene_city_shield")
		}
		self.unit_categories.FBI_shield.unit_types.america = {
			Idstring("units/payday2/characters/ene_city_shield/ene_city_shield")
		}
		self.unit_categories.CS_tazer.unit_types.america = {
			Idstring("units/payday2/characters/ene_tazer_1/ene_tazer_1")
		}
		self.unit_categories.spooc.unit_types.america = {
			Idstring("units/payday2/characters/ene_spook_1/ene_spook_1")
		}
		self.unit_categories.medic_M4.unit_types.america = {
			Idstring("units/payday2/characters/ene_medic_m4/ene_medic_m4")
		}
		self.unit_categories.medic_R870.unit_types.america = {
			Idstring("units/payday2/characters/ene_medic_r870/ene_medic_r870")
		}
--Riflemen
		if self.gsoed_menu_data and self.gsoed_menu_data.light_rifleman == 1 then
			self.unit_categories.CS_swat_MP5.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_1/ene_city_swat_1"),
				Idstring("units/payday2/characters/ene_city_swat_3/ene_city_swat_3")
			}
			self.unit_categories.FBI_swat_M4.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_1/ene_city_swat_1"),
				Idstring("units/payday2/characters/ene_city_swat_3/ene_city_swat_3")
			}
		end
		if self.gsoed_menu_data and self.gsoed_menu_data.light_rifleman == 2 then
			self.unit_categories.CS_swat_MP5.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_1/ene_city_swat_1")
			}
			self.unit_categories.FBI_swat_M4.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_1/ene_city_swat_1")
			}
		end
		if self.gsoed_menu_data and self.gsoed_menu_data.light_rifleman == 3 then
			self.unit_categories.CS_swat_MP5.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_3/ene_city_swat_3")
			}
			self.unit_categories.FBI_swat_M4.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_3/ene_city_swat_3")
			}
		end
--Shotgunners
		if self.gsoed_menu_data and self.gsoed_menu_data.light_shotgunner == 1 then
			self.unit_categories.CS_swat_R870.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_2/ene_city_swat_2"),
				Idstring("units/payday2/characters/ene_city_swat_r870/ene_city_swat_r870")
			}
			self.unit_categories.FBI_swat_R870.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_2/ene_city_swat_2"),
				Idstring("units/payday2/characters/ene_city_swat_r870/ene_city_swat_r870")
			}
		end
		if self.gsoed_menu_data and self.gsoed_menu_data.light_shotgunner == 2 then
			self.unit_categories.CS_swat_R870.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_r870/ene_city_swat_r870")
			}
			self.unit_categories.FBI_swat_R870.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_r870/ene_city_swat_r870")
			}
		end
		if self.gsoed_menu_data and self.gsoed_menu_data.light_shotgunner == 3 then
			self.unit_categories.CS_swat_R870.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_2/ene_city_swat_2")
			}
			self.unit_categories.FBI_swat_R870.unit_types.america = {
				Idstring("units/payday2/characters/ene_city_swat_2/ene_city_swat_2")
			}
		end
	end
--Bulldozers below MH
	if difficulty_index <= 5 then
		self.unit_categories.FBI_tank.unit_types.america = {
			Idstring("units/payday2/characters/ene_bulldozer_1/ene_bulldozer_1"),
			Idstring("units/payday2/characters/ene_bulldozer_2/ene_bulldozer_2"),
			Idstring("units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3")
		}
	end
--Bulldozers on MH
	if difficulty_index == 6 then
		self.unit_categories.FBI_tank.unit_types.america = {
			Idstring("units/payday2/characters/ene_bulldozer_1/ene_bulldozer_1"),
			Idstring("units/payday2/characters/ene_bulldozer_2/ene_bulldozer_2"),
			Idstring("units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3"),
			Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_minigun_classic/ene_bulldozer_minigun_classic")
		}
	end
--Bulldozers above MH
	if difficulty_index >= 7 then
		self.unit_categories.FBI_tank.unit_types.america = {
			Idstring("units/payday2/characters/ene_bulldozer_1/ene_bulldozer_1"),
			Idstring("units/payday2/characters/ene_bulldozer_2/ene_bulldozer_2"),
			Idstring("units/payday2/characters/ene_bulldozer_3/ene_bulldozer_3"),
			Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_minigun_classic/ene_bulldozer_minigun_classic"),
			Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_medic/ene_bulldozer_medic")
		}
	end
--Heavies below DS
	if difficulty_index <= 7 then
		self.unit_categories.CS_heavy_M4.unit_types.america = {
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36")
		}
		self.unit_categories.CS_heavy_R870.unit_types.america = {
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870")
		}
		self.unit_categories.FBI_heavy_G36.unit_types.america = {
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36")
		}
		self.unit_categories.FBI_heavy_R870.unit_types.america = {
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870")
		}
	end
--Heavies on DS
	if difficulty_index == 8 then
		self.unit_categories.FBI_heavy_G36.unit_types.america = {
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"),
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"),
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"),
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"),
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"),
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"),
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"),
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36"),
			Idstring("units/payday2/characters/ene_city_heavy_g36/ene_city_heavy_g36")
		}
		self.unit_categories.FBI_heavy_R870.unit_types.america = {
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"),
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"),
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"),
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"),
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"),
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"),
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"),
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870"),
			Idstring("units/payday2/characters/ene_city_heavy_r870/ene_city_heavy_r870")
		}
	end
--ZEAL Marksmen
	if self.gsoed_menu_data.zeal_marksman and difficulty_index == 8 then
		table.insert(self.unit_categories.FBI_heavy_G36.unit_types.america, Idstring("units/pd2_dlc_drm/characters/ene_zeal_swat_heavy_sniper/ene_zeal_swat_heavy_sniper"))
		table.insert(self.unit_categories.FBI_heavy_R870.unit_types.america, Idstring("units/pd2_dlc_drm/characters/ene_zeal_swat_heavy_sniper/ene_zeal_swat_heavy_sniper"))
	end
end)