﻿--Creates the options menu
_G.GSOEDMenu = _G.GSOEDMenu or {}
GSOEDMenu._path = ModPath
GSOEDMenu._data_path = ModPath .. "menu/settings.json"
GSOEDMenu._data = {}

function GSOEDMenu:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self._data ) )
		file:close()
	end
end

function GSOEDMenu:Load()
	local file = io.open( self._data_path, "r" )
	if file then
		self._data = json.decode( file:read("*all") )
		file:close()
	end
    if not GSOEDMenu._data.light_rifleman then GSOEDMenu._data.light_rifleman = 1 end
    if not GSOEDMenu._data.light_shotgunner then GSOEDMenu._data.light_shotgunner = 1 end
    if not GSOEDMenu._data.medic_rifle then GSOEDMenu._data.medic_rifle = false end
    if not GSOEDMenu._data.medic_shotgun then GSOEDMenu._data.medic_shotgun = false end
    if not GSOEDMenu._data.zeal_marksman then GSOEDMenu._data.zeal_marksman = false end
end

Hooks:Add("LocalizationManagerPostInit", "GenSec_localize_menu", function(loc)
	loc:load_localization_file(GSOEDMenu._path .. "menu/english.json")
end)

Hooks:Add("MenuManagerInitialize", "GenSec_init_menu", function(menu_manager)
	MenuCallbackHandler.gsoed_light_rifleman_callback = function(self, item)
		GSOEDMenu._data.light_rifleman = item:value()
		GSOEDMenu:Save()
	end

	MenuCallbackHandler.gsoed_light_shotgunner_callback = function(self, item)
		GSOEDMenu._data.light_shotgunner = item:value()
		GSOEDMenu:Save()
	end

	MenuCallbackHandler.gsoed_medic_rifle_callback = function(self, item)
		GSOEDMenu._data.medic_rifle = (item:value() == "on" and true or false)
		GSOEDMenu:Save()
	end

	MenuCallbackHandler.gsoed_medic_shotgun_callback = function(self, item)
		GSOEDMenu._data.medic_shotgun = (item:value() == "on" and true or false)
		GSOEDMenu:Save()
	end

	MenuCallbackHandler.gsoed_zeal_marksman_callback = function(self, item)
		GSOEDMenu._data.zeal_marksman = (item:value() == "on" and true or false)
		GSOEDMenu:Save()
	end

	GSOEDMenu:Load()

	MenuHelper:LoadFromJsonFile(GSOEDMenu._path .. "menu/menu.json", GSOEDMenu, GSOEDMenu._data)
end)